
#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>
#include "statsme.h"

player_t	players[33];
announce_t	score;
motd_t*		sm_motd;
menu_t*		sm_menu;

void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax )
{
	for(int i = 0; i < 33; ++i){
		players[i].pEdict = NULL;
		players[i].index = 0;
		players[i].freqtime = 0;
		players[i].team_name[0] = '\0';
		players[i].deaths = 0;
		players[i].kills = 0;
		players[i].valid = false;
		players[i].ingame = false;
		players[i].current_weapon = 0;
		players[i].ip[0] = '\0';
		players[i].health = 0;
		players[i].armor = 0;
		players[i].money = 0;
		players[i].tkpunish = NULL;
		players[i].punish_me = false;
		players[i].punish_time = 0.0;
		memset(players[i].a_weapons,0,sizeof(players[i].a_weapons));
		memset(players[i].p_hits,0,sizeof(players[i].p_hits));
		memset(players[i].p_dmg,0,sizeof(players[i].p_dmg));
		memset(players[i].p_killed,'\0',sizeof(players[i].p_killed));
		memset(players[i].pList,NULL,sizeof(players[i].pList));
		players[i].p_killer	= 0;
		players[i].p_delay	= 0;
		players[i].send_stats = false;
		players[i].start_action = MENU_IDLE;
		players[i].menu_keys = 0;
		players[i].menu_state = 0;
		players[i].player_num = 0;
		players[i].grenade = NULL;
		players[i].grenade_time = 0.0;
		players[i].show_statsme_menu = 0;
		players[i].latency_sum = 0;
		players[i].latency_samples = 0;
		players[i].play_time = 0;
	}

	memset(score.mosthits,0,sizeof(score.mosthits));
	memset(score.mostdmg,0,sizeof(score.mosthits));
	memset(score.bestkill,0,sizeof(score.bestkill));
	memset(score.besths,0,sizeof(score.besths));
	memset(score.game_score,0,sizeof(score.game_score));
	memset(score.freqkill,0,sizeof(score.freqkill));
	memset(score.freqhs,0,sizeof(score.freqhs));
	score.bomb_time = 0;
	score.mp_c4timer= -1;
	score.mp_c4word= NULL;
	score.player1= NULL;
	score.player2= NULL;
	score.player3= NULL;
	score.damage= 0;
	score.hits= 0;
	score.shots= 0;
	score.tks= 0;
	score.killer= NULL;
	score.victim= NULL;
	score.heads= 0;
	score.kills= 0;
	score.deaths= 0;
	score.weapon= NULL;
	score.money= 0;
	score.clip= 0;
	score.ammo= 0;
	score.health= 0;
	score.armor = 0;
	score.eff = 0;
	score.acc = 0;
	score.attackers_list = NULL;
	score.show_score = 0;	;
	score.score_type = 0;
	score.stats_time = 0;
	score.timeleft[0] = '\0';
	score.ping = 0;
	score.packet_loss = 0;
	modUnSetNum = 0;

// Due to many problems on some systems during top15 loading from file,
// I've removed ability for saving stats to file.
// It seems to be useless because stats are reset every three days and ppl don't care if
// stats will be reset on server restart.

//LoadRank(); // load ranking (top15)
	time_t currenttime; time(&currenttime); //get current time
	if (difftime(currenttime,score.last_save) > ((int)sm_resetrank->value * 3600)) {
		memset(&rank,0,sizeof(rank)); //reset stats
		time(&score.last_save);
	}


	if (gmsgCurWeapon) { // do init below only once
		RETURN_META(MRES_IGNORED);
	}

	gmsgCurWeapon	=	GET_USER_MSG_ID(PLID, "CurWeapon", NULL );
	gmsgDamage		=	GET_USER_MSG_ID(PLID, "Damage", NULL );
	gmsgDeathMsg	=	GET_USER_MSG_ID(PLID, "DeathMsg", NULL );
	gmsgTextMsg		=	GET_USER_MSG_ID(PLID, "TextMsg", NULL );
	gmsgWeapPickup	=	GET_USER_MSG_ID(PLID, "WeapPickup", NULL );
	gmsgTeamInfo	=	GET_USER_MSG_ID(PLID, "TeamInfo", NULL );
	gmsgWeaponList	=	GET_USER_MSG_ID(PLID, "WeaponList", NULL );
	gmsgResetHUD	=   GET_USER_MSG_ID(PLID, "ResetHUD", NULL );
	gmsgMOTD		=	GET_USER_MSG_ID(PLID, "MOTD", NULL );
	gmsgServerName	=	GET_USER_MSG_ID(PLID, "ServerName", NULL );
	gmsgHealth		=	GET_USER_MSG_ID(PLID, "Health", NULL);
	gmsgBattery		=	GET_USER_MSG_ID(PLID, "Battery", NULL);
	gmsgShowMenu	=	GET_USER_MSG_ID(PLID, "ShowMenu", NULL);
	gmsgSendAudio	=	GET_USER_MSG_ID(PLID, "SendAudio", NULL);
	gmsgTeamScore	=	GET_USER_MSG_ID(PLID, "TeamScore", NULL);
	gmsgMoney		=	GET_USER_MSG_ID(PLID, "Money", NULL);
	gmsgAmmoX		=	GET_USER_MSG_ID(PLID, "AmmoX", NULL);

	for(int a=0,size=0; a < MAX_REG_MSGS; ++a){
		const char *cp=GET_USER_MSG_NAME(PLID, a, &size);
		if(cp && !strcmp("intermission?",cp)){
			gmsgintermission = a;
			break;
		}
	}

	memset(modMsgs,NULL,sizeof(modMsgs));
	memset(modMsgEnds,NULL,sizeof(modMsgEnds));
	modMsgs[gmsgCurWeapon].modMsgFunction = Client_CurWeapon;
	modMsgs[gmsgDamage].modMsgFunction = Client_Damage;
	modMsgs[gmsgDeathMsg].modMsgFunction = Client_DeathMsg;
	modMsgs[gmsgTextMsg].modMsgFunction = Client_TextMsg;
	modMsgs[gmsgWeapPickup].modMsgFunction = Client_WeapPickup;
	modMsgs[gmsgTeamInfo].modMsgFunction = Client_TeamInfo;
	modMsgs[gmsgWeaponList].modMsgFunction = Client_WeaponList;
	modMsgs[gmsgMOTD].modMsgFunction = Client_CurWeapon;
	modMsgs[gmsgHealth].modMsgFunction = Client_Health;
	modMsgs[gmsgBattery].modMsgFunction = Client_Battery;
	modMsgs[gmsgShowMenu].modMsgFunction = Client_ShowMenu;
	modMsgs[gmsgSendAudio].modMsgFunction = Client_SendAudio;
	modMsgs[gmsgTeamScore].modMsgFunction = Client_TeamScore;
	modMsgs[gmsgMoney].modMsgFunction = Client_Money;
	modMsgs[gmsgAmmoX].modMsgFunction = Client_AmmoX;
	modMsgEnds[gmsgintermission].modMsgFunction = Client_intermission;
	modMsgEnds[gmsgResetHUD].modMsgFunction = Client_ResetHUD;
	mp_c4timer=CVAR_GET_POINTER("mp_c4timer");

	RETURN_META(MRES_IGNORED);
}

void ServerDeactivate( void ) {
	player_t *pPlayer;
	for (int a = 1; a <= gpGlobals->maxClients; ++a){		
		pPlayer = GET_PLAYER_POINTER_I(a);
		if (pPlayer->valid && !pPlayer->send_stats)	{
			pPlayer->send_stats = true;
			AddPlayerToRank(pPlayer);
		}
	}
	//	SaveRank(); //save ranking (top15)
	//clear adminmod plugin calls
	for(int i=0; i < MAX_REG_MSGS; i++)	{
		if (!modMsgFunCalls[i])
			continue;
		fun_call_t*start = modMsgFunCalls[i];
		fun_call_t*next = start;
		while (next){
			start = start->next;
			delete[] next->cmd;
			cond_t*cpnext = next->cond;
			cond_t*cp = cpnext;
			while(cp){ //delete all conditions from fun_call_t
				cpnext = cpnext->next;
				delete[] cp->toval;
				delete cp;
				cp = cpnext;
			}
			delete next;
			next = start;
		}
		modMsgFunCalls[i] = NULL;
	}
	//clear motd
	motd_t*start=sm_motd;
	motd_t*next=start;
	while(next){
		start = start->next;
		delete[] next->msg;
		delete next;
		next = start;
	}
	sm_motd = NULL;
	//clear menu
	menu_t*start_m=sm_menu;
	menu_t*next_m=start_m;
	while(next_m){
		start_m = start_m->next;
		delete[] next_m->name;
		delete[] next_m->cmd;
		delete next_m;
		next_m = start_m;
	}
	sm_menu= NULL;
	RETURN_META(MRES_IGNORED);
}

void PlayerPreThink_Post( edict_t *pEntity ) 
{
	int index = ENTINDEX(pEntity);
	player_t *pPlayer = GET_PLAYER_POINTER_I(index);

	// Latency measure - thx to PsychoGuard
    if (pPlayer->latency_log_time > 0 && pPlayer->latency_log_time < gpGlobals->time) {	
		pPlayer->latency_log_time = gpGlobals->time + (int)sm_latlogfreq->value;
		int ping, packet_loss;
		PLAYER_CNX_STATS(pPlayer->pEdict, &ping, &packet_loss);
		if (ping > 0) {
			pPlayer->latency_sum += ping;
			pPlayer->latency_samples++;
		}
	}

	// if this is after kill then check for monster kill!
	if (pPlayer->freqtime > 0 && SM_MODE(MONSTER_ON) && pPlayer->freqtime < gpGlobals->time){
		pPlayer->freqtime = 0;
		if (score.freqkill[index] >= sm_monsterkillnum->value){
			score.kills = score.freqkill[index];
			score.heads = score.freqhs[index];
			score.killer = pPlayer;
			
			DO_THE_ACTION(sm_monsterkill->string);
		}
		score.freqkill[index] = 0;
		score.freqhs[index] = 0;
	}

	// delay for life score - Victim and Attacker list
	// must be with delay due to fact that death msg is before hurt messages
	if (pPlayer->p_delay > 0 && pPlayer->p_delay < gpGlobals->time)	{
		pPlayer->p_delay = -1;
		static char death_score[512];
		static char d_temp[128];
		bool status_changed = false;
		bool hbkilled;
		score.victim = pPlayer;
		score.attackers_list = death_score;
		int len = 0;
		if (SM_MODE(AL_ON)){ // Attackers
			death_score[0]=0;
			for (int d = 1; d <= gpGlobals->maxClients; ++d){
				if (d!=index&&players[d].ingame&&players[d].p_hits[index]){
					status_changed = true;
					hbkilled = (pPlayer->p_killer == d); //check if player have killed us
					len+=sprintf(&death_score[len],"%s -- %d hit(s) / %d dmg%s%s\\n",
						STRING(players[d].pEdict->v.netname),
						players[d].p_hits[index],players[d].p_dmg[index],
						hbkilled ? " with ":" ",hbkilled ? players[d].p_killed[index] : " ");
				}
			}	
			if (status_changed){ // show only if there are some data to display
				DO_THE_ACTION(sm_attackers->string);
			}	
		}
		if (SM_MODE(VL_ON)){ //Victims	
			death_score[0]=0; 
			len = 0;
			status_changed = false;
			for (int c = 1; c <= gpGlobals->maxClients; ++c){
				if (c!=index&&pPlayer->p_hits[c]){
					status_changed = true;
					hbkilled = (pPlayer->p_killed[c]!=NULL); //check if we have killed that player
					len+=sprintf(&death_score[len],"%s -- %d hit(s) / %d dmg%s%s\\n",
						STRING(players[c].pEdict->v.netname),
						pPlayer->p_hits[c],pPlayer->p_dmg[c],
						hbkilled ? " with ":" ", hbkilled ? pPlayer->p_killed[c] : " ");
				}
			}
			if (status_changed){
				DO_THE_ACTION(sm_victims->string);
			}
		}
	}

	// tkpunish
	if (pPlayer->punish_time > 0 && pPlayer->punish_time < gpGlobals->time) {
		pPlayer->punish_time = 0;
		MDLL_ClientKill(pEntity);
	}

	// delayed menu
	if (pPlayer->show_statsme_menu > 0 && pPlayer->show_statsme_menu < gpGlobals->time) {
		pPlayer->show_statsme_menu = 0;
		StatsMeMenu(pPlayer, pPlayer->menu_state);
	}

	RETURN_META(MRES_IGNORED);
}

// Go through all weapons and collect info about them
void MakeStats(player_t *pPlayer, char* pList)
{
	pList[0] = '\0';
	int len = 0;
	int hits = 0;
	int shots = 0;
	int	health = 0;		
	// overall stats
	for (int c = 0; weapon_select[c].iId ; ++c)	{
		if (pPlayer->a_weapons[weapon_select[c].iId].bulletsfired) 	{	
			shots += pPlayer->a_weapons[weapon_select[c].iId].bulletsfired;
			hits += pPlayer->a_weapons[weapon_select[c].iId].bulletshit;
			health += pPlayer->a_weapons[weapon_select[c].iId].health;
		}
	}
				
	score.ping = pPlayer->latency_samples ? (pPlayer->latency_sum / pPlayer->latency_samples) : 0;
	score.time = (int)gpGlobals->time - pPlayer->play_time;
	score.acc = ACCURACY_FORMULA(shots,hits);
	score.eff = EFFEC_FORMULA(pPlayer->kills,pPlayer->deaths);
	score.kills = pPlayer->kills;
	score.deaths = pPlayer->deaths;
	score.hits = hits;
	score.shots = shots;
	score.damage = health;
	// fill sm_playerstats with collected data
	len+=sprintf(pList,UTIL_FillWithVars(sm_playerstats->string));
	// specified for each weapon
	for (int i = 0; weapon_select[i].iId ; ++i)	{
		if (pPlayer->a_weapons[weapon_select[i].iId].bulletsfired) 	{
			wpn_stat_t& this_weapon = pPlayer->a_weapons[weapon_select[i].iId];
			score.hits = this_weapon.bulletshit;
			score.damage = this_weapon.health;
			score.heads = this_weapon.headshot;
			score.kills = this_weapon.kills;
			score.tks = this_weapon.tk;
			score.deaths = this_weapon.deaths;
			score.weapon = weapon_select[i].name;
			score.shots = this_weapon.bulletsfired;
			score.acc = ACCURACY_FORMULA(score.shots,score.hits);
			score.eff = EFFEC_FORMULA(score.kills,score.deaths);
			len+=sprintf(&pList[len],UTIL_FillWithVars(sm_weaponstats->string));
		}
	}
}

void StartFrame_Post( void )
{
	//unset done ADMINMOD plugins calls
	for(int i = 0; i < modUnSetNum; ++i)
		modUnSetDone[i]->done = false;
	modUnSetNum = 0;

	//bomb counting down
	if (score.mp_c4timer > 0 && score.bomb_time < gpGlobals->time){
		score.bomb_time = gpGlobals->time + 1.0;	
		--score.mp_c4timer;
		int freq = sm_bombfreq->value ? sm_bombfreq->value : 1; //exclude division by 0
		if (score.mp_c4timer <= sm_bombcont->value || (score.mp_c4timer % freq)==0){
			char time_in_word[64];
			UTIL_IntToString(score.mp_c4timer, time_in_word);
			score.mp_c4word = time_in_word;
			char* say_time_left = UTIL_FillWithVars((score.mp_c4timer <= sm_bombcont->value) ? 
				sm_bombtimecont->string :  sm_bombtimefreq->string);
			SERVER_COMMAND(say_time_left);
		}
	}
	
	if (score.show_score > 0 && score.show_score < gpGlobals->time)	{
		score.show_score = 0.0;
		//go through all score and find out who is the best
		int who_is_the_man = 0, a;
		score.kills = 0;
		score.heads = 0;
		//go through all score and find out who is the most damage dist.
		int who_damage = 0;
		score.damage = 0;
		score.hits = 0;
		// get guy with highest score or if has the same score then take with more headshots
		for (a = 1; a <= gpGlobals->maxClients ; ++a){
			if (score.kills < score.bestkill[a]||(score.kills==score.bestkill[a]&&score.heads<score.besths[a]) ){	
				score.kills = score.bestkill[a];
				score.heads = score.besths[a];
				who_is_the_man = a;
			}				
			if (score.damage<score.mostdmg[a]||(score.damage==score.mostdmg[a]&&score.hits<score.mosthits[a])){
				score.hits = score.mosthits[a];
				score.damage = score.mostdmg[a];
				who_damage = a;
			}	
			// display victims and attackers lists at the end of round 
			// haven't done it yet (i.e. on players death)
			if (players[a].p_delay != -1)
				players[a].p_delay = gpGlobals->time + 0.02;
		}
		// reset all stats for round
		memset(score.besths,0,sizeof(score.besths));
		memset(score.bestkill,0,sizeof(score.bestkill));
		memset(score.mostdmg,0,sizeof(score.mostdmg));
		memset(score.mosthits,0,sizeof(score.mosthits));
		//score.accplayer = GET_PLAYER_POINTER_I(who_accurate);
		score.player2 = GET_PLAYER_POINTER_I(who_damage);
		score.killer = GET_PLAYER_POINTER_I(who_is_the_man);
		if (SM_MODE(ROUND_ON) && who_is_the_man){//sm_say \'Best killer: %M\\nwith %K kills (%H headshots)\\nScore: CT %C -- T %T\'
			DO_THE_ACTION(sm_roundend->string);
		}
		if (SM_MODE(BDWS_ON) && (score.score_type==2)) {//bomb has been defused
			DO_THE_ACTION(sm_bombdefused->string);
		} 
		else if (SM_MODE(BDF_ON) && (score.score_type==3) && (score.player1) ){ //bomb has not been defused
			DO_THE_ACTION(sm_bombfailure->string);
		}
		score.score_type = 0;
	}

	//intermission is on and delay has been achived - show stats to all players
	if (score.stats_time > 0 && score.stats_time < gpGlobals->time)	{
		score.stats_time = 0.0;
		if (SM_MODE(SCORE_ON)){
			char pList[1024];
			player_t *pPlayer;
			for (int a = 1; a <= gpGlobals->maxClients; ++a){		
				pPlayer = GET_PLAYER_POINTER_I(a);
				if (pPlayer->valid)	{
					MakeStats(pPlayer,pList);
					UTIL_ShowMOTD(pPlayer->pEdict,pList, STRING( pPlayer->pEdict->v.netname ));	
				}
			}
		}
	}	

	RETURN_META(MRES_IGNORED);
}

BOOL ClientConnect_Post( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
	player_t* pPlayer = GET_PLAYER_POINTER(pEntity);
	pPlayer->pEdict = pEntity;
	strcpy(pPlayer->ip,pszAddress); //save ip address of this player
	pPlayer->play_time	= (int)gpGlobals->time; //start time like original "status"

	if (sm_motd){
		char* echo_motd;
		score.victim = pPlayer;
		for(motd_t*p = sm_motd;p;p=p->next){
			echo_motd = UTIL_FillWithVars(p->msg);
			if (!echo_motd||!echo_motd[0])
				continue; //SKIP! function used or just null string
			CLIENT_COMMAND(pEntity,echo_motd);
		}
	}

	RETURN_META_VALUE(MRES_IGNORED, TRUE);
}

void ClientDisconnect( edict_t *pEntity ) 
{
	player_t *pPlayer = GET_PLAYER_POINTER(pEntity);
	
	//Go through weapons stats and log only fired/used weapons
	for (int i = 0; weapon_select[i].iId ; ++i)	{
		if (pPlayer->a_weapons[weapon_select[i].iId].bulletsfired) 	{
			wpn_stat_t& this_weapon = pPlayer->a_weapons[weapon_select[i].iId];
			score.hits = this_weapon.bulletshit;
			score.damage = this_weapon.health;
			score.heads = this_weapon.headshot;
			score.kills = this_weapon.kills;
			score.tks = this_weapon.tk;
			score.deaths = this_weapon.deaths;
			score.weapon = weapon_select[i].name;
			score.shots = this_weapon.bulletsfired;
			score.acc = ACCURACY_FORMULA(score.shots,score.hits);
			score.eff = EFFEC_FORMULA(score.kills,score.deaths);
			UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"weaponstats\" %s",
				STRING( pEntity->v.netname ), 
				GETPLAYERUSERID( pEntity ),
				GETPLAYERWONID( pEntity ),
				pPlayer->team_name,
				UTIL_FillWithVars(sm_logformat->string));

			score.wpn_stats = &this_weapon;
			UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"detailed_weaponstats\" %s",
				STRING( pEntity->v.netname ), 
				GETPLAYERUSERID( pEntity ),
				GETPLAYERWONID( pEntity ),
				pPlayer->team_name,
				UTIL_FillWithVars(sm_detailedlogformat->string));
		}
	}
		
	if (pPlayer->latency_samples > 0) {
	    score.ping = pPlayer->latency_sum / pPlayer->latency_samples;
	    UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"latency\" %s",
			   STRING(pPlayer->pEdict->v.netname),
			   GETPLAYERUSERID(pPlayer->pEdict),
			   GETPLAYERWONID(pPlayer->pEdict),
			   pPlayer->team_name,
			   UTIL_FillWithVars(sm_latlogformat->string));
	}

	if ( sm_timelogformat->string[0] ) {
		score.time = (int)gpGlobals->time - pPlayer->play_time;
		UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"time\" %s",
			STRING(pPlayer->pEdict->v.netname),
			GETPLAYERUSERID(pPlayer->pEdict),
			GETPLAYERWONID(pPlayer->pEdict),
			pPlayer->team_name,
			UTIL_FillWithVars(sm_timelogformat->string));
	}

	if (!pPlayer->send_stats){
		pPlayer->send_stats = true;
		AddPlayerToRank(pPlayer);
	}

	pPlayer->latency_log_time = 0;
	pPlayer->valid = false;
	pPlayer->ingame	= false;

	RETURN_META(MRES_IGNORED);
}

void ClientPutInServer_Post( edict_t *pEntity ) {

	int index				= ENTINDEX(pEntity);
	player_t *pPlayer		= GET_PLAYER_POINTER_I(index);

	pPlayer->index			= index;
	pPlayer->pEdict			= pEntity;
	pPlayer->kills			= 0;
	pPlayer->deaths			= 0;
	pPlayer->freqtime		= 0;
	pPlayer->current_weapon	= 0;
	pPlayer->p_delay		= -1;
	pPlayer->p_killer		= 0;

	pPlayer->valid			= ( GETPLAYERWONID(pEntity) > 0 ) ? true : false;
	pPlayer->punish_me		= false;
	pPlayer->send_stats		= false;
	pPlayer->ingame			= true;

	pPlayer->can_display	= true;

	pPlayer->tkpunish		= NULL;
	pPlayer->punish_time	= 0.0;

	pPlayer->latency_sum		= 0;
	pPlayer->latency_samples	= 0;
	pPlayer->show_statsme_menu	= 0;

	pPlayer->latency_log_time = (*sm_latlogformat->string && (int)sm_latlogfreq->value)
		? (gpGlobals->time + (int) sm_latlogfreq->value) : 0;

	score.besths[index]		= 0;
	score.bestkill[index]	= 0;
	score.freqhs[index]		= 0;
	score.freqkill[index]	= 0;
	score.mostdmg[index]	= 0;
	score.mosthits[index]	= 0;

	// reset weapon stats
	memset(pPlayer->a_weapons,0,sizeof(pPlayer->a_weapons));

	RETURN_META(MRES_IGNORED);
}

void ClientCommand( edict_t *pEntity )
{
	static char pList[1024];
	player_t *pPlayer = GET_PLAYER_POINTER(pEntity);
	if (!strcmp(CMD_ARGV(0),"say")){
		if (SM_MODE(TOP_ON)&&!strcmp(CMD_ARGV(1),sm_rankcmd->string)){// top15
			ShowTopScore(pPlayer);
			RETURN_META(MRES_IGNORED);
		}
		if (SM_MODE(STATS_ON)&&!strcmp(CMD_ARGV(1),sm_statsmecmd->string)){ // statsme
			MakeStats(pPlayer,pList);
			UTIL_ShowMOTD(pEntity,pList, STRING( pEntity->v.netname ));
			RETURN_META(MRES_IGNORED);
		}
		if (SM_MODE(STATS_ON)&&!strcmp(CMD_ARGV(1),sm_statscmd->string)){ // stats
			StatsMenu(pPlayer, 0);
			RETURN_META(MRES_IGNORED);
		}		
		if (pPlayer->tkpunish&&!strcmp(CMD_ARGV(1),sm_forgivetkcmd->string)){ //forgivetk
			UTIL_ClientPrintMsgAll(HUD_PRINTTALK, "* %s forgave %s\n",
				STRING(pPlayer->pEdict->v.netname),
				STRING(pPlayer->tkpunish->pEdict->v.netname));
			pPlayer->tkpunish->punish_me = false;
			pPlayer->tkpunish = NULL;
			RETURN_META(MRES_IGNORED);
		}
		if (!strcmp(CMD_ARGV(1),sm_switchcmd->string)){ //switch
			if (pPlayer->can_display) {
				pPlayer->can_display = false;
				UTIL_ClientPrint(pEntity,HUD_PRINTTALK,"* You will no longer see/hear statsme announcements.\n");
			}
			else {
				pPlayer->can_display = true;
				UTIL_ClientPrint(pEntity,HUD_PRINTTALK, "* You have enabled statsme announcements.\n");
			}
			RETURN_META(MRES_IGNORED);
		}
	}
	else if (!strcmp(CMD_ARGV(0), "menuselect" )){
		if (pPlayer->start_action == STATS_MENU)	{ // menu
			int pressed_key = atoi( CMD_ARGV(1) );
			if (pPlayer->menu_keys&(1<<pressed_key)){
				int begin_select = (pPlayer->menu_state*8);
				switch(pressed_key){
				case 9:
					StatsMenu(pPlayer, pPlayer->menu_state+1);
					break;
				case 10:
					StatsMenu(pPlayer, pPlayer->menu_state-1);		
					break;
				default:
					begin_select += (pressed_key-1);
					MakeStats(pPlayer->pList[begin_select],pList);
					UTIL_ShowMOTD(pEntity,pList,STRING(pPlayer->pList[begin_select]->pEdict->v.netname ));
					StatsMenu(pPlayer, pPlayer->menu_state);
				}
			}
			RETURN_META(MRES_SUPERCEDE);
		}
		else if (pPlayer->start_action == STATSME_MENU)	{
			int pressed_key = atoi( CMD_ARGV(1) );
			if (pPlayer->menu_keys&(1<<pressed_key)){
				int begin_select = (pPlayer->menu_state*8);
				switch(pressed_key){
				case 9:
					StatsMeMenu(pPlayer, pPlayer->menu_state+1);
					break;
				case 10:
					StatsMeMenu(pPlayer, pPlayer->menu_state-1);		
					break;
				default:{
					begin_select += (pressed_key-1);
					menu_t*a=sm_menu;
					for(int c = 0;c<begin_select;c++) a=a->next;
					DO_THE_ACTION(a->cmd);
					pPlayer->show_statsme_menu = gpGlobals->time + 0.2; //doh - we must use here delay
					}
				}
			}
			RETURN_META(MRES_SUPERCEDE);
		}
	}
	else if (SM_MODE(STATUS_ON)&&!strcmp(CMD_ARGV(0),sm_statuscmd->string)){ // report
		for (int i = 0; weapon_select[i].iId; ++i){
			if (weapon_select[i].iId == pPlayer->current_weapon){
				score.weapon = weapon_select[i].name;
				score.money = pPlayer->money;
				score.ammo = pPlayer->a_weapons[weapon_select[i].iId].ammo;
				score.clip = pPlayer->a_weapons[weapon_select[i].iId].lastammo;
				score.killer = pPlayer;
				CLIENT_COMMAND(pEntity,"say_team %s",UTIL_FillWithVars(CMD_ARGS()));
				RETURN_META(MRES_SUPERCEDE);
			}
		}
	}
	else if (!strcmp(CMD_ARGV(0),"statsme_menu") && *sm_menupassword->string &&
			!strcmp(sm_menupassword->string,CMD_ARGV(1)))	{
		StatsMeMenu(pPlayer, 0);
		RETURN_META(MRES_SUPERCEDE);
	}


	RETURN_META(MRES_IGNORED);
}

DLL_FUNCTIONS gFunctionTable_Post;
C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ) {
	gFunctionTable_Post.pfnClientConnect = ClientConnect_Post;
	gFunctionTable_Post.pfnClientPutInServer = ClientPutInServer_Post;
	gFunctionTable_Post.pfnServerActivate = ServerActivate_Post;
	gFunctionTable_Post.pfnPlayerPreThink = PlayerPreThink_Post;
	gFunctionTable_Post.pfnStartFrame = StartFrame_Post;
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

DLL_FUNCTIONS gFunctionTable;
C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion ){
	gFunctionTable.pfnClientDisconnect = ClientDisconnect;
	gFunctionTable.pfnClientCommand = ClientCommand;
	gFunctionTable.pfnServerDeactivate = ServerDeactivate;
	memcpy( pFunctionTable, &gFunctionTable, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,					// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,					// pfnGetEntityAPI_Post			META; called after game DLL
	GetEntityAPI2,			// pfnGetEntityAPI2				HL SDK2; called before game DLL
	GetEntityAPI2_Post,		// GetEntityAPI2_Post,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,					// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,					// GetNewDLLFunctions_Post,	// pfnGetNewDLLFunctions_Post	META; called after game DLL
	GetEngineFunctions,		// pfnGetEngineFunctions		META; called before HL engine
	GetEngineFunctions_Post	// pfnGetEngineFunctions_Post	META; called after HL engine
};