

#include <stdio.h>
#include <stdarg.h>

#include <extdll.h>

#include "engine_api.h"
#include "meta_api.h"
#include "statsme.h"

int	gmsgCurWeapon=0;
int	gmsgDeathMsg;
int	gmsgDamage;
int	gmsgTextMsg;
int	gmsgWeapPickup;
int	gmsgTeamInfo;
int	gmsgWeaponList;
int	gmsgResetHUD;
int	gmsgintermission;
int gmsgMOTD;
int gmsgServerName;
int gmsgHealth;
int gmsgAmmoX;
int gmsgBattery;
int gmsgShowMenu;
int gmsgSendAudio;
int gmsgTeamScore;
int gmsgMoney;

fun_call_t* modUnSetDone[64];
fun_call_t*	modMsgFunCalls[MAX_REG_MSGS];
fun_call_t*	modMsgCalledFun;
fun_me_t modMsgEnds[MAX_REG_MSGS];
fun_me_t modMsgs[MAX_REG_MSGS];
void (*modMsgFunction)(void*);
void (*modMsgEndFunction)(void*);
player_t* modMsgPlayer;
char modMsgCmd[512];
int	 modMsgLen;
int	modUnSetNum;
int modValIter;
int modMsgiTarget;
int	modMsgState;

struct quotes_t{const char *sInt, *sFloat, *sStr ;};
quotes_t wqts = {"\"%d\" ","\"%.4f\" ","\"%s\" "};
quotes_t woqts = {"%d ","%.4f ","%s "};
quotes_t* modFrm;

void MessageBegin_Post(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed) {
	if (ed){
		modMsgiTarget = ENTINDEX(ed);
		modMsgPlayer = GET_PLAYER_POINTER_I(modMsgiTarget);
	} else {
		modMsgiTarget = 0;
		modMsgPlayer = NULL;
	}
	modMsgState	= 0;
	modValIter = 0;
	modMsgEndFunction=modMsgEnds[msg_type].modMsgFunction;
	modMsgFunction=modMsgs[msg_type].modMsgFunction;
	modMsgCalledFun=modMsgFunCalls[msg_type];
	if (modMsgCalledFun){
		fun_call_t*p;
		for(p=modMsgCalledFun;p;p=p->next){
			if (p->done||(modMsgPlayer?p->player:p->world))continue;
			p->done=true;
			modUnSetDone[modUnSetNum++]=p;
		}
		for(p=modMsgCalledFun;p;p=p->next){
			if (p->done)continue;
			modMsgCalledFun=p;
			modFrm=modMsgCalledFun->quotes?&wqts:&woqts;
			modMsgLen=sprintf(&modMsgCmd[64],modFrm->sInt,modMsgiTarget) + 64;
			RETURN_META(MRES_IGNORED);
		}
		modMsgCalledFun = NULL;
	}
	RETURN_META(MRES_IGNORED);
}

void CheckConditions(int len){
	++modValIter;
	bool skip; cond_t*a;
	for (fun_call_t*p=modMsgCalledFun;p;p=p->next){
		if (p->done||!p->cond)continue;
		skip=true;
		for (a=p->cond;a;a=a->next){
			if (a->val!=modValIter) continue;
			skip=false;
			if (strncmp(&modMsgCmd[modMsgLen+p->quotes],a->toval,a->tovallen)==0){
				skip=true;
				break;
			}
		}
		if (skip) continue;
		p->done=true;
		modUnSetDone[modUnSetNum++]=p;
	}
	modMsgLen+=len;
}

void MessageEnd_Post(void) {
	if (modMsgEndFunction) (*modMsgEndFunction)(NULL);
	if (modMsgCalledFun){
		modMsgCmd[modMsgLen-1] = ';';
		for (fun_call_t*p=modMsgCalledFun;p;p=p->next){
			if (p->done)continue;
			memcpy(&modMsgCmd[p->where],p->cmd,p->len);
			SERVER_COMMAND(&modMsgCmd[p->where]);
			if (!p->once)continue;
			p->done=true;
			modUnSetDone[modUnSetNum++]=p;
		}
	}
	RETURN_META(MRES_IGNORED);
}

void WriteByte_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteChar_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteShort_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteLong_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}
void WriteAngle_Post(float flValue) {
	if (modMsgFunction) (*modMsgFunction)((void *)&flValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sFloat,flValue));
	RETURN_META(MRES_IGNORED);
}
void WriteCoord_Post(float flValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&flValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sFloat,flValue));
	RETURN_META(MRES_IGNORED);
}
void WriteString_Post(const char *sz) {
	if (modMsgFunction)	(*modMsgFunction)((void *)sz);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sStr,sz));
	RETURN_META(MRES_IGNORED);
}
void WriteEntity_Post(int iValue) {
	if (modMsgFunction)	(*modMsgFunction)((void *)&iValue);
	if (modMsgCalledFun) CheckConditions(sprintf(&modMsgCmd[modMsgLen],modFrm->sInt,iValue));
	RETURN_META(MRES_IGNORED);
}

void SetModel(edict_t *e, const char *m){
	if(e->v.owner&&!strncmp(m,"models/w_h",10)){
		int i = ENTINDEX(e->v.owner);
		if (i > 0 && i < 33){
			players[i].grenade = e;
			players[i].grenade_time = gpGlobals->time + 1.75;
			if (players[i].current_weapon > 0 && players[i].current_weapon  < MAX_WEAPONS)
				players[i].a_weapons[players[i].current_weapon].bulletsfired++;
		}
	}
	RETURN_META(MRES_IGNORED);
}

void TraceLine(const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr) {
	TRACE_LINE(v1, v2, fNoMonsters, pentToSkip, ptr);
	if (ptr->iHitgroup && pentToSkip && (pentToSkip->v.flags & IS_PLAYER))//only if we hit at something
		(GET_PLAYER_POINTER(pentToSkip))->aimed_at = ptr->iHitgroup;
	RETURN_META(MRES_SUPERCEDE);
}

enginefuncs_t meta_engfuncs_post;
C_DLLEXPORT int GetEngineFunctions_Post(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) {
	meta_engfuncs_post.pfnMessageBegin = MessageBegin_Post;
	meta_engfuncs_post.pfnMessageEnd = MessageEnd_Post;
	meta_engfuncs_post.pfnWriteByte = WriteByte_Post;
	meta_engfuncs_post.pfnWriteChar = WriteChar_Post;
	meta_engfuncs_post.pfnWriteShort = WriteShort_Post;
	meta_engfuncs_post.pfnWriteLong = WriteLong_Post;
	meta_engfuncs_post.pfnWriteAngle = WriteAngle_Post;
	meta_engfuncs_post.pfnWriteCoord = WriteCoord_Post;
	meta_engfuncs_post.pfnWriteString = WriteString_Post;
	meta_engfuncs_post.pfnWriteEntity =  WriteEntity_Post;
	memcpy(pengfuncsFromEngine, &meta_engfuncs_post, sizeof(enginefuncs_t));
	return TRUE;
}

enginefuncs_t meta_engfuncs;
C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) {
	meta_engfuncs.pfnSetModel = SetModel;
	meta_engfuncs.pfnTraceLine = TraceLine;
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return TRUE;
}
