
#ifndef STATSME_H
#define STATSME_H

#include <time.h>			// time()
#include <enginecallback.h>		// ALERT()
#include <sdk_util.h>			// UTIL_VarArgs()
#include <api_info.h>
#include <string.h>

#define VDATE			"14/05/2002"
#define VVERSION		"2.1.17"
#define RC_VERS_DWORD	2,1,17,0,0	// Version Windows DLL Resources in res_meta.rc

#define VNAME			"STATSME"
#define VAUTHOR			"OLO"
#define VURL			"www.olo.counter-strike.pl"
#define VLOGTAG			"STATSME"

// Various strings for the Windows DLL Resources in res_plugin.rc
#define RC_COMMENTS		"STATSME"
#define RC_DESC			"STATSME - Metamod Plugin DLL"
#define RC_FILENAME		"statsme_mm.dll"
#define RC_INTERNAL		"STATSME"
#define RC_COPYRIGHT	"Copyright 2002 OLO"

#define ACCURACY_FORMULA(a,b) ((a) ? ( ((float)b * 100.00) / (float)a ) : 0.00 )// a = shots, b = hits
#define EFFEC_FORMULA(a,b) ((b + a) ? ( ((float)a * 100.00) / (float)( b + a ) ) : 0.00 )// a = kills, b = deaths
#define DO_THE_ACTION(a) SERVER_COMMAND(UTIL_FillWithVars(a));

#define HITGROUP_GENERIC 0
#define HITGROUP_HEAD 1
#define HITGROUP_CHEST 2
#define HITGROUP_STOMACH 3
#define HITGROUP_LEFTARM 4
#define HITGROUP_RIGHTARM 5
#define HITGROUP_LEFTLEG 6
#define HITGROUP_RIGHTLEG 7

// menu ids
enum MENU_STATE{
	MENU_IDLE,
	STATS_MENU,
	STATSME_MENU
};

struct cond_t {
	int	val; //position of value to check
	char* toval; //value to compare
	int	tovallen; //length of value to cmpare
	cond_t* next;
};

// names of commands to call
struct fun_call_t {
	char*cmd;			// commnad to execute
	bool player;		// receiver is a specified player
	bool world;			// receivers are all players
	bool done;			// does this func has been already excetued and can't be called again?
	bool once;			// keeps condition for value above
	int len;			// length of this command
	int where;			// diffrences from 64 (my internal usage)
	int quotes;			// does this call uses quotes
	cond_t* cond;		// list of condition (filter)
	fun_call_t*next;	// next call in list
};

// weapon stats - used by player to store theirs personal weapon stats
struct wpn_stat_t {
	int	bulletsfired;
	int	bulletshit;
	int	lastammo;
	int	headshot;
	int	kills;
	int	tk;
	int	health;
	int	deaths;
	int	ammo;
	// some more details
	int	hitgroup[10]; //more slots just in case
};

// well maybe it's to late for class but for futher development it may be very usefull
struct player_t {
	edict_t*	pEdict;
	int			index;
	float		freqtime;
	char		team_name[64];
	int			deaths;
	int			kills;
	bool		valid;
	bool		ingame;
	int			current_weapon;
	char		ip[32];
	int			health;
	int			armor;
	int			money;
	player_t*	tkpunish;
	bool		punish_me;
	float		punish_time;
	wpn_stat_t	a_weapons[MAX_WEAPONS+1];
	int			p_killer;
	float		p_delay; //we must show life score with delay to allow all data to be updated
	int			p_hits[33];
	int			p_dmg[33];
	const char*	p_killed[33];
	bool		send_stats;
	MENU_STATE	start_action;
	int			menu_keys;
	int			menu_state;
	int			player_num;
	player_t*	pList[33];
	edict_t*	grenade;
	float		grenade_time;
	long int	latency_sum;
	long int	latency_samples;
	float		show_statsme_menu;
	float		latency_log_time;
	int			play_time;
	bool		can_display;
	int			aimed_at;
};

// struct which keeps misc. values for displaying on screen
struct announce_t {
	float		bomb_time;
	int			mp_c4timer;
	const char* mp_c4word;
	int			mosthits[33];
	int			mostdmg[33];
	player_t*	player1;
	player_t*	player2;
	player_t*	player3;
	int			damage;
	int			hits;
	int			shots;
	int			bestkill[33];
	int			 besths[33];
	int			game_score[2];
	int			freqkill[33];
	int			freqhs[33];
	int			tks;
	player_t*	killer;
	player_t*	victim;
	int			heads;
	int			kills;
	int			deaths;
	const char*	weapon;
	int			money;
	int			clip;
	int			ammo;
	int			health;
	int			armor;
	float		eff;
	float		acc;
	const char* attackers_list;
	float		show_score;
	int			score_type;
	float		stats_time;
	char		timeleft[8];
	int			ping;
	int			packet_loss;
	int			sm_mode;
	time_t		last_save;
	int			time;
	int			mod_id; //type of running mod
	char		mod_name[32]; //name of mod folder
	wpn_stat_t*	wpn_stats;	
};

// filled during weapon list engine message
struct wpn_sel_t {
	short int	iId;// the weapon id value
	short int	ammo1;//slot for ammo
	char		name[16];// name of the weapon when selecting it
};

// server rank
struct rank_t {
	char name[64];
	time_t time;		// time when player was last playing
	int points;		// points for rank
	int	hits;		// taken from all weapons
	int	shots;		// taken from all weapons
	int	kills;	
	int	deaths;
	int	dmg;		// overall damage :)
	int	tks;
	int	hs;			// headshots
	float eff;		// efficiency (kills to deaths)
	float acc;		// accuracy (hits to shots)
};

#define CLIENT_PRINTF (*g_engfuncs.pfnClientPrintf)
#define GET_PLAYER_POINTER(e) &players[ENTINDEX(e)]
#define GET_PLAYER_POINTER_I(i) &players[i]

extern int	gmsgDeathMsg;
extern int	gmsgDamage;
extern int	gmsgCurWeapon;
extern int	gmsgTextMsg;
extern int	gmsgWeapPickup;
extern int	gmsgTeamInfo;
extern int	gmsgWeaponList;
extern int	gmsgResetHUD;
extern int	gmsgMOTD;
extern int	gmsgServerName;
extern int	gmsgintermission;
extern int	gmsgHealth;
extern int	gmsgBattery;
extern int  gmsgShowMenu;
extern int  gmsgSendAudio;
extern int  gmsgTeamScore;
extern int	gmsgMoney;
extern int	gmsgAmmoX;

void Client_DeathMsg(void*);
void Client_Damage(void*);
void Client_CurWeapon(void*);
void Client_TextMsg(void*);
void Client_WeapPickup(void*);
void Client_TeamInfo(void*);
void Client_WeaponList(void*);
void Client_ResetHUD(void*);
void Client_Battery(void*);
void Client_Health(void*);
void Client_SendAudio(void*);
void Client_TeamScore(void*);
void Client_ShowMenu(void*);
void Client_Money(void*);
void Client_intermission(void*);
void Client_AmmoX(void*);

extern int  IS_PLAYER;
extern int modUnSetNum;
extern fun_call_t* modUnSetDone[64];
extern char	modMsgCmd[512];
extern bool	modMsgActive;
extern fun_call_t* modMsgFunCalls[MAX_REG_MSGS];
extern fun_call_t* modMsgCalledCvar;
extern int modMsgState;		//position in engine message
extern player_t* modMsgPlayer;		//target of message

#define	MOD_UNKNOW	0
#define	MOD_CSTRIKE	1

// keeps motd for players
struct motd_t {
	char*msg;
	motd_t*next;
};

struct menu_t {
	char*name;
	char*cmd;
	menu_t*next;
};

extern menu_t*		sm_menu;
extern int			menu_keys[];
extern motd_t*		sm_motd;
extern announce_t	score;
extern player_t		players[33];
extern rank_t		rank[65]; //keep stats only from first 32 players
extern wpn_sel_t	weapon_select[MAX_WEAPONS+1];

extern cvar_t	*statsme_version;
extern cvar_t	*sm_logformat;
extern cvar_t	*sm_knifekill;
extern cvar_t	*sm_headshot;
extern cvar_t	*sm_bombset;
extern cvar_t	*sm_bombtime;
extern cvar_t	*sm_kill;
extern cvar_t	*sm_monsterkill;
extern cvar_t	*sm_monsterkillnum;
extern cvar_t	*sm_roundend;
extern cvar_t	*sm_bombtimefreq;
extern cvar_t	*sm_bombtimecont;
extern cvar_t	*sm_bombfreq;
extern cvar_t	*sm_bombcont;
extern cvar_t	*sm_playerstats;
extern cvar_t	*sm_weaponstats;
extern cvar_t	*sm_menupassword;
extern cvar_t	*sm_monsterfreq;
extern cvar_t	*sm_bombdefused;
extern cvar_t	*sm_bombfailure;
extern cvar_t	*sm_attackers;
extern cvar_t	*sm_victims;
extern cvar_t	*sm_rankcmd;
extern cvar_t	*sm_statsmecmd;
extern cvar_t	*sm_statscmd;
extern cvar_t	*sm_forgivetkcmd;
extern cvar_t	*sm_killsforrank;
extern cvar_t	*sm_tkpunish;
extern cvar_t	*mp_c4timer;
extern cvar_t	*sm_resetrank;
extern cvar_t	*sm_statuscmd;
extern cvar_t	*sm_latlogformat;
extern cvar_t	*sm_latlogfreq;
extern cvar_t	*sm_switchcmd;
extern cvar_t	*sm_timelogformat;
extern cvar_t	*sm_detailedlogformat;

#define	STATS_ON	(1<<0) //allow for displaying stats during the game (say /statsme)
#define SCORE_ON	(1<<1) //show stats to all players at the end of map
#define KILL_ON		(1<<2) //announce normal kill
#define HEAD_ON		(1<<3) //announce headshot
#define MONSTER_ON	(1<<4) //announce monsterkill
#define BOMB_ON		(1<<5) //announce bomb set (only CS)
#define TIME_ON		(1<<6) //counting down to explosion (only CS)
#define ROUND_ON	(1<<7) //round end score (only CS)
//#define TKPUNISH_ON	(1<<8) //tkpunish
#define BDWS_ON		(1<<9) //bomb succesfully defused (only CS)
#define BDF_ON		(1<<10) //bomb defusing failure (only CS)
#define STAB_ON		(1<<11) //killing by knife (how far supports only "knife" weapon)
#define AL_ON		(1<<12) //attackers list
#define VL_ON		(1<<13) //victims list
#define TOP_ON		(1<<14) //top15 list
#define STATUS_ON	(1<<15) //info

// SM MODE
inline bool SM_MODE(int a) {
	return ((score.sm_mode & a)!=0);
}

void	statsme_init(void);
void	UTIL_ShowMOTD( edict_t *client , char *pList, const char *szName);
void	UTIL_HudMessage(const hudtextparms_t &textparms, char *pMessage, edict_t *pEntity);
void	UTIL_ClientPrintMsgAll( int msg_dest,  char *fmt, ... );
void	UTIL_ClientPrint( edict_t *pEntity, int msg_dest, char *fmt, ... );
void	UTIL_IntToString(int value, char *output);
char	*UTIL_FillWithVars(const char* src);
void	StatsMenu(player_t *pPlayer, int state);
void	StatsMeMenu(player_t *pPlayer, int state);
void	CmdSay(void);
void	CmdTell(void);
void	CmdClExec(void);
void	CmdMotd(void);
void	AddPlayerToRank(player_t* pPlayer);
void	ShowTopScore(player_t* pPlayer);
//void	LoadRank();
//void	SaveRank();

struct fun_me_t{
	void (*modMsgFunction)(void*);
};

extern fun_me_t modMsgs[MAX_REG_MSGS];
extern fun_me_t modMsgEnds[MAX_REG_MSGS];

#endif // STATSME_H
