
#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

//struct keeping names and indexes for weapons
wpn_sel_t weapon_select[MAX_WEAPONS+1]; 

void Client_ShowMenu(void* MsgValue) 
{
	modMsgPlayer->start_action = MENU_IDLE;
}

void Client_intermission(void* MsgValue)
{
	score.stats_time = gpGlobals->time + 2.0;
}

void Client_SendAudio(void* MsgValue){

	if (modMsgPlayer)
		return; //accept only global msg

	static const char *szSound;
	switch (modMsgState++) {
	case 1:
		szSound = (char*)MsgValue;
		if (!strcmp(szSound,"%!MRAD_BOMBPL")){
			if (SM_MODE(TIME_ON)){
				score.mp_c4timer = (int)mp_c4timer->value + 1;
				score.bomb_time	= 0;
			}
			if (SM_MODE(BOMB_ON)){//sm_say \'%B set us up the bomb!!!\'
				DO_THE_ACTION(sm_bombset->string);
			}
			score.player1 = NULL;
		}
		else if (!strcmp(szSound,"%!MRAD_BOMBDEF")){
			score.score_type = 2; //set bomb defuse msg
		}
		else if (!strcmp(szSound,"%!MRAD_terwin")||!strcmp(szSound,"%!MRAD_ctwin")||!strcmp(szSound,"%!MRAD_rounddraw")){
			score.mp_c4timer = -1; //stop bomb counting down
			score.show_score = gpGlobals->time + 0.02;
		}
	}
}

//Score teams (CT or T)
void Client_TeamScore(void* MsgValue){
	static const char *szTeam;
	switch (modMsgState++) {
	case 0:
		szTeam = (char*)MsgValue;
		break;
	case 1:
		if (!strcmpi(szTeam,"TERRORIST"))
			score.game_score[0] = *(int*)MsgValue;
		else if (!strcmpi(szTeam,"CT"))
			score.game_score[1] = *(int*)MsgValue;
	}
}

//msg send when text is send to client or all players
void Client_TextMsg(void* MsgValue) {
	static char* sText;
	//static char* sMin;
	//static char* sSec;
	switch (modMsgState++) {
	case 1:
		sText = (char*)MsgValue;
		if (modMsgPlayer){
			if (strncmp("#Defusing_Bomb",sText,14)==0)
				score.player1 = modMsgPlayer;
			else if (strncmp("#Game_n",sText,7)==0)
				strcpy(score.timeleft,"0");
		}
		else if (strncmp("#Target_B",sText,9)==0){
			score.score_type = 3; //set bomb trageted successfully
		}
	/*break;

	case 2:
		sMin = (char*)MsgValue;
		break;
	case 3:
		sSec = (char*)MsgValue;
		if (modMsgPlayer&&strncmp("#Game_ti",sText,8)==0)
			sprintf(score.timeleft,"%s:%s", sMin, sSec);
	*/
	}

}

// msg send on player respawn/spawn - used to determine new round in CS
void Client_ResetHUD(void* MsgValue)
{
	if ( sm_tkpunish->value && modMsgPlayer->punish_me ) {
		modMsgPlayer->punish_time = gpGlobals->time + 0.2;
	}

	memset(modMsgPlayer->p_dmg,0,sizeof(modMsgPlayer->p_dmg));
	memset(modMsgPlayer->p_hits,0,sizeof(modMsgPlayer->p_hits));
	memset(modMsgPlayer->p_killed,NULL,sizeof(modMsgPlayer->p_killed));

	modMsgPlayer->p_killer = 0;
	modMsgPlayer->p_delay = 0;
	modMsgPlayer->tkpunish = NULL;
	modMsgPlayer->punish_me = false;
}

// when player's team is changed then this msg is send to player
void Client_TeamInfo(void* MsgValue)
{	
	if (modMsgPlayer)
		return;

	static int index;
	switch (modMsgState++) {
	case 0:
		index = *(int*)MsgValue;
		break;
	case 1:
		strcpy(players[index].team_name,(char*)MsgValue); //save name of team
		players[index].index = index;
		players[index].pEdict = INDEXENT(index); // bots doesn't always pass through PutInServer(...)
		players[index].ingame = true; //that is why we must set player status again - just in case
	}
}

// msg send when player requests list of weapons from server
void Client_WeaponList(void* MsgValue)
{
	static int wpn_num;
	static int weapon_list;
	static int weapon_id;
	static int ammo_id;
	static const char* wpn_name;	
	
	switch (modMsgState++) {
	case 0:
		wpn_name = (char*)MsgValue;
		break;
	case 1:
		ammo_id = *(int*)MsgValue;
		break;
	case 7:
		weapon_id = *(int*)MsgValue;
		if ((wpn_num >= MAX_WEAPONS) || (weapon_list & (1<<weapon_id))) //check if weapon is not already listed
			break;
		weapon_list |= (1<<weapon_id); //Save this weapon
		weapon_select[wpn_num].iId = weapon_id;
		weapon_select[wpn_num].ammo1 = ammo_id;
		//trunk "weapon_" from weapon name
		strcpy(weapon_select[wpn_num++].name, (wpn_name + 7) );
	}	
}

// message gets sent when the players health changes
void Client_Health(void* MsgValue)
{
	modMsgPlayer->health = *(int*)MsgValue;  // health ammount
}

// message gets sent when the players armor changes
void Client_Battery(void* MsgValue)
{
	modMsgPlayer->armor = *(int*)MsgValue;  // armor ammount
}

// message gets sent when the players armor changes
void Client_AmmoX(void* MsgValue)
{
	static int iAmmo;
	switch (modMsgState++){
	case 0:
		iAmmo = *(int*)MsgValue;
		break;
	case 1:
		for(int i=0; weapon_select[i].iId; ++i){
			if (iAmmo == weapon_select[i].ammo1)
				modMsgPlayer->a_weapons[weapon_select[i].iId].ammo = *(int*)MsgValue;/*+ modMsgPlayer->a_weapons[iId].lastammo;*/
		}
	}
}

/* msg send on icon hud status change*/
void Client_WeapPickup(void* MsgValue)
{
	if (*(int*)MsgValue == 6) //6 is an ID of C4 and save this person as potentional bomb planter
		score.player1 = modMsgPlayer;
}

void Client_Money(void* MsgValue)
{
	switch (modMsgState++){
	case 0:
		modMsgPlayer->money = *(int*)MsgValue;
	}
}

/* msg send to update current status about weapon - ammo, active weapon etc.*/
void Client_CurWeapon(void* MsgValue)
{
	static int iState;
	static int iClip;
	static int iId;
	switch (modMsgState++){
	case 0:	
		iState = *(int*)MsgValue;
		break;
	case 1:	
		if (iState) { //active weapon have iState set to 1
			iId = *(int*)MsgValue;
			modMsgPlayer->current_weapon = iId; // weapon ID
		}
		break;
	case 2:
		if (iState){
			iClip = *(int*)MsgValue;
			//mark fired bullets only on decreasing
			if (iClip > -1 && iClip < modMsgPlayer->a_weapons[iId].lastammo)
				++modMsgPlayer->a_weapons[iId].bulletsfired;
			modMsgPlayer->a_weapons[iId].lastammo = iClip;
		}
	}
}

/* message about death (top-right corner) */
void Client_DeathMsg(void* MsgValue)
{	
	static bool	bHeadShot;
	static int iKiller;
	static player_t *pKiller;
	static int iVictim;
	static player_t *pVictim;
	static char* szWeapon;
	
	switch (modMsgState++){
	case 0: //get killer
		iKiller = *(int*)MsgValue;
		pKiller = (iKiller>0 && iKiller<33) ? GET_PLAYER_POINTER_I(iKiller) : NULL;
		break;
	case 1:	//get victim
		iVictim = *(int*)MsgValue;
		pVictim = (iVictim>0 && iVictim<33) ? GET_PLAYER_POINTER_I(iVictim) : NULL;
	case 2:	
		bHeadShot = (*(int*)MsgValue) ? true: false ;	
		break;
	case 3:
		//only if attacker and victim are valid and it's not the same player
		if (pKiller==pVictim||!pKiller||!pVictim)
			break;

		szWeapon = (char*)MsgValue;

		if (szWeapon[0]=='g'&&szWeapon[1]=='r'&&szWeapon[2]=='e') //"grenade"
			szWeapon = "hegrenade"; //hack - name not match

		int diffteam = strcmp(pKiller->team_name, pVictim->team_name);
		//we are going throw all weapons to match name with name from death message
		//then we will add there hs, kills and tks
		for (int i = 0; weapon_select[i].iId; ++i){
			if (FStrEq(szWeapon,weapon_select[i].name))	{
				pKiller->p_killed[iVictim] = weapon_select[i].name; //save for life score name of weapon
				if (bHeadShot) pKiller->a_weapons[weapon_select[i].iId].headshot++;	
				pKiller->a_weapons[weapon_select[i].iId].kills++;
				if (!diffteam) pKiller->a_weapons[weapon_select[i].iId].tk++;	
				break; //Nothing else to do here
			}
		}
		if (!diffteam){
			//only if command is defined (if you don't want to 
			//allow players to forgive then set proper sm_mode)
			if (sm_tkpunish->value){
				pVictim->tkpunish = pKiller;
				pKiller->punish_me = true;
			}
		}
		else {
			score.bestkill[iKiller]++;//for endround stats
			score.freqkill[iKiller]++;//for monsterkill
			if (bHeadShot)	{
				score.besths[iKiller]++;
				score.freqhs[iKiller]++;
			}
			pKiller->kills++;
			pVictim->deaths++;

			if (pVictim->current_weapon > 0 && pVictim->current_weapon < MAX_WEAPONS)
				pVictim->a_weapons[pVictim->current_weapon].deaths++;

			pKiller->freqtime = gpGlobals->time + sm_monsterfreq->value;
		}
		score.killer = pKiller;
		score.victim = pVictim;
		score.weapon = szWeapon;
		if (SM_MODE(STAB_ON)&&!strcmp(szWeapon,"knife")){ //knife kill
			DO_THE_ACTION(sm_knifekill->string);
		}
		if (SM_MODE(HEAD_ON) && bHeadShot){ //headshot kill
			DO_THE_ACTION(sm_headshot->string);
		}
		if (SM_MODE(KILL_ON)) { //normal kill			
			DO_THE_ACTION(sm_kill->string);
		}
		// announce who was your attacker and who you have attacked
		pVictim->p_delay = gpGlobals->time + 0.02;
		pVictim->p_killer = iKiller; //save who have killed you!
	}
}

// message send when player takes damage
void Client_Damage(void* MsgValue)
{
	// types of damage to ignore...
	//static int IGNORE_DAMAGE = (DMG_FALL|DMG_CRUSH|DMG_FREEZE|DMG_SHOCK|DMG_DROWN|DMG_NERVEGAS|DMG_RADIATION|DMG_DROWNRECOVER|DMG_ACID|DMG_SLOWBURN|DMG_SLOWFREEZE);
	static int damage_taken;
	static int damage_bits;
	static int health;
	static int	hindex;
	static int	eindex;
	static bool grenade;
	static edict_t *pEnemy; 
	static player_t *pAttacker; 

	switch (modMsgState++) {
	case 1:	
		damage_taken = *(int*)MsgValue;	
		break;
	case 2:	
		damage_bits = *(int*)MsgValue;

		if (!damage_taken)
			break;

		//if (damage_bits & IGNORE_DAMAGE) 
		//	break;// ignore certain types of damage...
		pEnemy = modMsgPlayer->pEdict->v.dmg_inflictor;

		if (!pEnemy) break;//no enemy no damage
			
		grenade = false;

		if (pEnemy->v.flags & IS_PLAYER){
			//do nothing - it's first because it's almost always true and it's the fastest check
		}
		else if(!strcmp(STRING(pEnemy->v.classname),"grenade"))	{
			grenade = true;
		}
		else {
			break; //not grenade and not player so skip it
		}

		//else {
		//	pEnemy = pEnemy->v.owner;
		//	if (!pEnemy || !(pEnemy->v.flags & IS_PLAYER)) 
		//		break;
		//}

		if (damage_taken){
			hindex = modMsgPlayer->index;

			if (grenade) {
				for (int i = 1; i <= gpGlobals->maxClients; ++i)
					if (pEnemy==players[i].grenade&&players[i].grenade_time>gpGlobals->time){
						eindex = i;
						pAttacker = GET_PLAYER_POINTER_I(eindex);
						pAttacker->a_weapons[4].health += damage_taken; 
						pAttacker->a_weapons[4].bulletshit++;
						break;
					}
			}
			else {
				eindex = ENTINDEX(pEnemy);
				pAttacker = GET_PLAYER_POINTER_I(eindex);
				if (pAttacker->current_weapon > 0 && pAttacker->current_weapon  < MAX_WEAPONS){
					pAttacker->a_weapons[pAttacker->current_weapon].health += damage_taken; 
					pAttacker->a_weapons[pAttacker->current_weapon].bulletshit++;
					pAttacker->a_weapons[pAttacker->current_weapon].hitgroup[pAttacker->aimed_at]++;
				}
			}

			if (eindex > 0 && eindex < 33) {//if this is a player
				score.mostdmg[eindex] += damage_taken;
				score.mosthits[eindex]++;
				pAttacker->p_hits[hindex]++;
				pAttacker->p_dmg[hindex] += damage_taken;
			}
		}
	}
}