
#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <time.h>
#include "statsme.h"	// me

#define RANK_VERSION	2

rank_t rank[65];

void UTIL_Pathname_Convert(char *pathname) {
	while (pathname && *pathname) {
#ifndef __linux__
		if (*pathname == '/') *pathname = '\\'; // convert to MS-DOS format 
#else
		if (*pathname == '\\') *pathname = '/'; // convert to Linux format
#endif
		++pathname;
	}
}

inline void zamien(rank_t& a, rank_t& b) {
	rank_t c=a; a=b; b=c;
}

void SortRank(rank_t *tablica,int lewy,int prawy)
{
	if (lewy < prawy) {
		int m=lewy;
		for(int i=lewy+1;i<=prawy;i++)
			if (tablica[i].points>tablica[lewy].points)
				zamien(tablica[++m],tablica[i]);
		zamien(tablica[lewy],tablica[m]);
		SortRank(tablica,lewy,m-1);
		SortRank(tablica,m+1,prawy);
	}
}

/*
void LoadRank()
{
	char* filename = UTIL_VarArgs("%s/statsme.log",score.mod_name);
	UTIL_Pathname_Convert(filename);
	FILE *bfp = fopen(filename, "rb");
	if (bfp){
		int thisversion = 0;
		fread(&thisversion, 1,sizeof(int), bfp);
		if (thisversion == RANK_VERSION){ //proceed only if version of log is the same
			time_t when, currenttime;
			time(&currenttime); //get current time
			fread(&when, 1,sizeof(time_t), bfp); //read when stats were last cleared
			if (difftime(currenttime,when) > ((int)sm_resetrank->value * 3600)) {
				memset(&rank,0,sizeof(rank)); //reset stats
				time(&score.last_save); //save date of this reset
			} else {
				fread(&rank, 1,sizeof(rank), bfp);
			}
		}
		fclose(bfp);
	}
	//else {
	//	LOG_ERROR(PLID, "couldn't load ranks");
	//}	

}

void SaveRank()
{
	char* filename = UTIL_VarArgs("%s/statsme.log",score.mod_name);
	UTIL_Pathname_Convert(filename);
	FILE *bfp = fopen(filename, "wb");
	if (bfp){
		int rankversion = RANK_VERSION;
		fwrite(&rankversion, 1, sizeof(int) , bfp);
		fwrite(&score.last_save, 1, sizeof(time_t) , bfp);
		fwrite(&rank, 1, sizeof(rank) , bfp);
		fclose(bfp);
	}
	//else {
	//	LOG_ERROR(PLID, "couldn't save ranks");
	//}
}
*/

// used to set points for rank - set here your own rules for scoring the player
void GivePoints(rank_t*pos)
{
	pos->points = (int)(pos->eff) + (int)pos->acc + ((int)(pos->hs)/5);

	if (pos->kills < (int)sm_killsforrank->value)
		pos->points /= 2;
}

void AddPlayerToRank(player_t* pPlayer)
{
	if (!pPlayer->valid){
		return; //skip bots
	}

	const char* nick = STRING(pPlayer->pEdict->v.netname);
	int hits = 0, shots = 0, dmg = 0, tks = 0, hs = 0;		
	// overall weapon stats
	for (int c = 0; weapon_select[c].iId ; ++c)	{
		if (pPlayer->a_weapons[weapon_select[c].iId].bulletsfired) 	{
			hits += pPlayer->a_weapons[weapon_select[c].iId].bulletshit;
			shots += pPlayer->a_weapons[weapon_select[c].iId].bulletsfired;
			tks += pPlayer->a_weapons[weapon_select[c].iId].tk;
			dmg += pPlayer->a_weapons[weapon_select[c].iId].health;
			hs += pPlayer->a_weapons[weapon_select[c].iId].headshot;
		}
	}

	//if already exists then add score to this existing one
	for (int i = 0; i < 64; ++i) {
		if (strncmp(nick,rank[i].name,32)==0)	{
			time (&rank[i].time);
			rank[i].tks += tks;
			rank[i].dmg += dmg;
			rank[i].deaths += pPlayer->deaths;
			rank[i].kills += pPlayer->kills;
			rank[i].shots += shots;
			rank[i].hits += hits;
			rank[i].hs += hs;
			rank[i].acc = ACCURACY_FORMULA(rank[i].shots,rank[i].hits);
			rank[i].eff = EFFEC_FORMULA(rank[i].kills,rank[i].deaths);
			GivePoints(&rank[i]);
			SortRank(rank,0,64);
			return;
		}
	}

	//if not then save to last place and compare with score table (we are tracking only first 32 places)
	int a = 64;
	strncpy(rank[a].name,nick,32); 
	rank[a].name[32] = 0; //terminal strncpy
	time (&rank[a].time);
	rank[a].tks = tks;
	rank[a].dmg = dmg;
	rank[a].deaths = pPlayer->deaths;
	rank[a].kills = pPlayer->kills;
	rank[a].shots = shots;
	rank[a].hits = hits;
	rank[a].hs = hs;
	rank[a].acc = ACCURACY_FORMULA(rank[a].shots,rank[a].hits);
	rank[a].eff = EFFEC_FORMULA(rank[a].kills,rank[a].deaths);
	GivePoints(&rank[a]);
	SortRank(rank,0,64);
}

#define MAX_MOTD_LENGTH   2048

//define it to view points with which rank is sort
//#define SHOW_POINTS

void ShowTopScore(player_t* pPlayer)
{
	static char besthall[MAX_MOTD_LENGTH+1];
	static char *spaces = "....................................."; //used to fromat rank list
	int len = 0;
#ifdef 	SHOW_POINTS
	len+=sprintf(besthall,"#  nick                     kills/deaths   hits/shots/hs.   eff.%%   acc.%%   pt.\n");
#else
	len+=sprintf(besthall,"#  nick                     kills/deaths   hits/shots/hs.   eff.%%   acc.%%\n");
#endif
	for (int i = 0; i < 15 && rank[i].name[0] ; ++i) {

#ifdef 	SHOW_POINTS
		len+=sprintf(&besthall[len], UTIL_VarArgs("%d. %s%s%d/%d   %d/%d/%d   %.2f   %.2f  %d\n",
			i + 1, rank[i].name, spaces+(int)(strlen(rank[i].name)*1.6), rank[i].kills , 
			rank[i].deaths,rank[i].hits, rank[i].shots,rank[i].hs,  rank[i].eff, rank[i].acc, rank[i].points));
#else
		len+=sprintf(&besthall[len], UTIL_VarArgs("%d. %s%s%d/%d   %d/%d/%d   %.2f   %.2f\n",
			i + 1, rank[i].name, spaces+(int)(strlen(rank[i].name)*1.6), rank[i].kills , 
			rank[i].deaths,rank[i].hits, rank[i].shots,rank[i].hs,  rank[i].eff, rank[i].acc));
#endif

	}

	UTIL_ShowMOTD(pPlayer->pEdict,besthall, "Top 15");
}